const {OD,OASGN,sign_str,add_repr,is_ary,is_bigint,is_cls_or_func,is_jprim} = require("nv-facutil-basic");
const _str                         = require("nv-string-basic");
const _fbsc                        = require("nv-file-basic");
const _S                           = require("nv-server-simple-stream").http.simple;
const _chown_with_name             = require("nv-cli-user").chown_with_name;
const _rrequire                    = require("nv-facutil-rrequire");
const _init_db                     = require("nv-question-repo-db").init;
const _cmmn                        = require("nv-remote-user-local-eng")._cmmn;
const _path                        = require("path");
const _err                         = require("nv-error-basic")

const DFLT_404_HANDLE = async(D,res,srv) => {
    let r = await _S.reply_with_json(res,[-404,"正在升级中"]);
    return(r)
}


const DFLT_NGINX_USER = "www-data";
const DFLT_USOCK      = "___nv_question_repo___";
const DFLT_DB_NAME    = "wangpoapp";
const DFLT_TBL_NAME   = require("nv-question-repo-db").DFLT_TBL_NAME;

const DFLT_VALIDATE = async(reqD,route,srv) => {
     let req_headers = reqD.headers;
     let req_body    = _cmmn.buf2json(reqD.body);
     ////
     let USER       = srv.cfg.USER;            //用户池
     let OSS        = srv.cfg.OSS;             //存储系统 
     ////
     return([true,null]) 
}

const DFLT_CFG = ()=>({
   ////
   USER:globalThis.USER,
   OSS:globalThis.OSS,
   validate:DFLT_VALIDATE, 
   //// 
   sock:{ 
       nginx_user:DFLT_NGINX_USER,
       usock:DFLT_USOCK,
   },
   db:{ 
       dbname:DFLT_DB_NAME,
       tbl:DFLT_TBL_NAME,
   }
});


class Srv {
    cfg  = DFLT_CFG();
    srv  = null;
    db   = null;
    oss  = null;
    ////--- 
    handle_dict = {};
    set_handle(route,afunc,reload=false) {
       if(afunc === undefined) {
           let p = _str.trim(route,"/");
           let arr = p.split("/");
           p = arr.join("-");
           if(reload) {
                this.handle_dict[route] = DFLT_404_HANDLE;
                _rrequire.unrequire("./route/"+p);
           } else {}
           this.handle_dict[route] = require("./route/"+p);
       } else {
           this.handle_dict[route] = afunc;
       }
   }
   ////
}

const ROUTES   = require("nv-question-repo-db").ROUTES;

async function creat(cfg=DFLT_CFG()) {
    let ncfg = OASGN(DFLT_CFG(),cfg);
    //--enable service:--
    let srv = new Srv();
    srv.cfg = ncfg;
    //--conn database:----
    srv.db  = await _init_db(srv.cfg.db.dbname,srv.cfg.db.tbl,srv.cfg.OSS);
    // http-server
    srv.srv = await _S.creat(ncfg.sock.usock);
    add_repr(srv.srv.constructor,(that)=>that._pipeName);
    _chown_with_name(ncfg.sock.usock,ncfg.sock.nginx_user);
    //--- USER POOL---
    Object.defineProperty(srv,"USER_",{get:function(){return(srv.cfg.USER)}});
    Object.defineProperty(srv,"OSS_",{get:function(){return(srv.cfg.OSS)}});
    Object.defineProperty(srv,"validate_",{get:function(){return(srv.cfg.validate)}});
    //--add handle  最后接
    srv.set_handle("/question/repo/debug/handle/list");            //
    srv.set_handle("/question/repo/debug/handle/change");          //___debug___  熱更新   最後做  類似ftp-srv項目的做法
    //// --
    for(let route in ROUTES) {  // {route:method}
        srv.set_handle(route)
    }
    //handle wrap
    srv.srv.handler_ = async (req,res) => {
        let D     = await _S.extract_req(req);
        let afunc = srv.handle_dict[D.path];
        if(afunc===undefined) {
            return(await _S.reply_with_json(res,null))
        } else {
            return(await afunc(D,res,srv));
        }
    }
    //
    return(srv)
}


const _fmt_rslt = (nvj)=> {
    if(is_ary(nvj)) {
        for(let i=0;i<nvj.length;i++) {
           let d = nvj[i];
           for(let k in d) {
               let v = d[k]
               if(is_bigint(v)) {
                   d[k] = String(v)
               } else {}
           }
           nvj[i] =d;
        }
        return(nvj)
    } else if(is_jprim(nvj)) {
        return(nvj)
    } else if(is_cls_or_func(nvj)) {
        return(nvj.toString())
    } else if(is_bigint(nvj)){
        return(String(nvj))
    } else {
        for(let k in nvj) {
           let v = nvj[k]
           if(is_bigint(v)) {
               nvj[k] = String(v)
           } else {}
        }
        return(nvj)
    }
}

const creat_handle = (route,db_method)=> {
    let _f = async(D,res,srv) => {
        let [cond,err] = await srv.validate_(D,route,srv);
        if(cond) {
             let db = srv.db;
             try {
                 let data    = _cmmn.buf2json(D.body);
                 data.oper   = err;                     //err is userid now
                 let rslt    = await db[db_method](data);                //rslt already be [cond,R]
                 rslt        = [rslt[0],_fmt_rslt(rslt[1])];
                 //let r       = await _S.reply_with_json_br(D,res,rslt);   
                 let r       = await _S.reply_with_json(res,rslt);
                 return(r)
             } catch(e) {
                 e = _err.to_json(e);
                 //let r = await _S.reply_with_json_br(D,res,[false,e]);
                 let r = await _S.reply_with_json(res,[false,e])
                 return(r)
             }
        } else {
            //let r = await _S.reply_with_json_br(D,res,[false,e]);
            let r = await _S.reply_with_json(res,[false,e])
            return(r)
        }
    }
    return(_f)
}

const route_filename_to_route = (fn)=> {
    let d = _path.parse(fn);
    let name = d.name;
    let route = '/'+name.replace(/\-/g,"/");
    return(route)
}

module.exports = {
   route_filename_to_route,
   creat_handle, 
   Srv,
   DFLT_CFG,
   DFLT_VALIDATE,
   creat,
}

