const _S                            = require("nv-server-simple-stream").http.simple;
const _fac_bsc                      = require("nv-facutil-basic");
const _cmmn                         = require("nv-remote-user-local-eng")._cmmn;
const {
    get_user_with_utoken,
    get_uname_from_nd,
    get_dict_from_unode,
}                                   = require("nv-remote-user-local-eng")._eng;
const _super                        = require("nv-remote-user-local-eng")._super;

const FORBIDDEN = [
    "/question/repo/debug/handle/list",
    "/question/repo/debug/handle/change"
]

module.exports = async(D,res,srv) => {
    let USER = srv.USER_;                      //用户池
    let {utoken} = D.headers;
    let user = get_user_with_utoken(USER,utoken);
    if(user === null) {
         let r = await _S.reply_with_json(res,_super.rtrn_err("未登录"));
         return(r)
    } else {
         let uname = get_uname_from_nd(user);
         if(uname !== "___debug___") {
             let r = await _S.reply_with_json(res,_super.rtrn_err("权限不足"));
             return(r)
         } else {
             let j = _cmmn.buf2json(D.body);
             let handle_dict = srv.handle_dict;
             let D = {}
             for(let route in handle_dict) {
                  if(!FORBIDDEN.includes(route)) {
                      D[route]= handle_dict[route].toString();  
                  }
             }
             let r = await _S.reply_with_json(res,_super.rtrn_ok(D));
             return(r)
         }
    }
}
